// =====================  GrLibPcx.cpp =====================
//
//   㭪樨 ⥭  䠩  뢮  ࠭ ࠦ
//    ଠ .PCX.
// ==========================================================


#ifndef __GRLIBPCX_CPP
#define __GRLIBPCX_CPP


#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <dos.h>
#include <math.h>
#include <string.h>
#include <graphics.h>



// --------- ᪨ 樨  ᥫ ----------
#define COPY	     0x00
#define AND          0x01
#define OR           0x02
#define XOR          0x03

// -------- ॣ ᪮ ஫ -----------
#define GDC                  0x3CE
#define GDCReset             0x00
#define GDCEnable            0x01
#define GDCColorCompare      0x02
#define GDCDataRotate        0x03
#define GDCReadMapSel        0x04
#define GDCMode              0x05
#define GDCMisc              0x06
#define GDCColorDC           0x07
#define GDCBitMask           0x08


#define EgaBase     0xA0000000L		//.  


// -----------  䠩 ଠ .PCX -------------
struct PCXheader
{ char  manuf;		//ᥣ = 10  Paintbrush
  char  hard;		// 
  char  encod;		//稥 㯯 ஢ (=1)
  char  bitpx;		//-  ᪮   ᥫ
  int   x1;		//ࠧ ⨭ ( ࠭)
  int   y1;
  int   x2;
  int   y2;
  int   hres;		//⨪쭮  ਧ⠫쭮 ࠧ襭
  int   vres;		//ᯫ,  ஬ ᮧ ࠦ
unsigned char  clrma[48];	//
  char  vmode;		//
  char  nplanes;	//⢮ ᪮⥩ ( ᨨ 2.5 = 0)
  int   bplin;		//  ப
  int   palinfo;	// (1-梥⭠, 2-୮-)
  int   shres;		//ࠧ襭 ᪠
  int   svres;
  char  xtra[54];	//१ࢭ  (䨫)
};// -------------   䠩 ଠ .PCX -------------


 char  op = COPY;			//᪠   㬮砭
 FILE  *fp = NULL;			//⮪ ᭮ 䠩





// ======================== ⠩ ======================
int mktimer(long=0)		//প  (1/1,000,000 ᥪ)
{ static char far *t1;
  asm{push es;
     mov dx,[bp+4];mov cx,[bp+6];	//뢠 প
     les bx,t1;				// 䫠  ES:BX
     cmp cx,0;jne a1;cmp dx,0;jne a1;
     mov al,es:[bx];shl al,1;jnc a2;inc dx;jmp a2;}
 a1: *t1=0;				//㫥 䫠
     asm{les bx,t1;mov ah,0x83;mov al,0;int 0x15;}
 a2: asm{pop es;}
 return _DX;
} //====================  ⠩ ==================






// ================ ⠭ ॣ஢ ========================
void  openScreen(unsigned char col)
{outportb(GDC,GDCReset);outportb(GDC+1,col);  // 梥  ॣ set/reset
 outportb(GDC,GDCEnable);outportb(GDC+1,0x0F);  // ᪮⥩  
 outportb(GDC,GDCDataRotate);outportb(GDC+1,op<<3);//   梥⮬
} // =============  ⠭ ॣ஢ ===================




// ========== ⠭ ॣ஢  㬮砭 ==================
void  closeScreen(void)
{outportb(GDC,GDCBitMask);outportb(GDC+1,0xFF);   //᪠ ⮢  㬮砭
 outportb(GDC,GDCEnable);outportb(GDC+1,0);       // ᪮⥩  
 outportb(GDC,GDCDataRotate);outportb(GDC+1,op<<0);  //   㬮.
}// ========  ⠭ ॣ஢  㬮砭 ==============




// ============  梥 ࠬ ࠭ ===============
void setOverscan(char i)
{ asm{mov ah,0x10;mov al,1;mov bh,i;int 0x10;}
} // ==========   梥 ࠬ ࠭ ===========





// ===============  ⥪饩  =================
void getColor(char far* colorBuf,	//  
	      int  fir=0,		// 砫쭮 ॣ DAC
	      int  num=64)		//᫮ ॣ஢ DAC
{ asm{push es;mov ah,0x10;mov al,0x17;mov cx,num;mov bx,fir;
      les dx,colorBuf;int 0x10; pop es;}
} // ===============   ⥪饩  =================





// ============   256   =============
void setColor256(char far* colorBuf,	// 
	      int  fir=0,		// 砫쭮 ॣ DAC
	      int  num=64)		//᫮ ॣ஢ DAC
{ asm{push es;mov ax,0x40;mov es,ax;mov dx,es:[0x63];
      add dl,6;mov ah,0x10;mov cx,num;mov bx,fir;}
  l1: asm{in al,dx;test al,8;jnz l1;}	// 砭 . . 室
  l2: asm{in al,dx;test al,8;jz  l2;	// 砫 . . 室
      mov al,0x12;les dx,colorBuf;int 0x10;pop es}
} // =========    256   =========






// =================   PCX   =================
void setColor(char far* colorBuf)	//colorBuf -  
{ asm{push si;push ds;lds si,colorBuf;xor dl,dl;mov ah,0x10;}
  lo: asm{mov al,0x7;mov bl,dl;int 0x10;mov al,0x10;mov bl,bh;xor bh,bh;
      mov dh,[si];inc si;shr dh,1;shr dh,1;
      mov ch,[si];inc si;shr ch,1;shr ch,1;
      mov cl,[si];inc si;shr cl,1;shr cl,1;
      int 0x10;inc dl;cmp dl,16;jb lo;pop ds;pop si;}
} // =============    PCX   =============





// ===========     梥 ===========
void setColorOne(char num,				// 梥
		 char red, char green, char blue)	//梥
{ asm{push es;mov ah,0x10;mov al,0x7;mov bl,num;int 0x10;mov bl,bh;
      xor bh,bh;mov ah,0x10;mov al,0x10;mov dh,red;mov ch,green;
      mov cl,blue;int 0x10; pop es;}
} // =======      梥 =======








// ====================   =====================
int screenPal(char far *col,		// 
	      char far *colOld,		// 
	     int st = 30,		//᫮ 蠣   
	     float t = 0.5,		//६  
	     int beg = 0,		//砫 ॣ DAC
	     int num = 64)		//᫮ ॣ஢ DAC
{   char *col1;int *col3, *col2;	//ࠡ稥 
    int i, j;				//ࠡ稥 ६
  if(st>63) st=63; if(st<1) st=1;	//஫ ᫠ 室
   col1=(char*)calloc(3*num,sizeof(char));
   col2=(int*) calloc(3*num,sizeof(int));
   col3=(int*) calloc(3*num,sizeof(int));
  if(col1==NULL||col2==NULL||col3==NULL)
    {printf("\n 墠⠥ !\n");return 1;}
   long tt=1000000*t/st; if(st<=1) tt=0;	//⠭ ࢠ
 //. ⠭ ஢
 for(i=0;i<3*num;i++)
   {col3[i]=(int)colOld[i]<<4; col2[i]=((int)(col[i]-colOld[i])<<4)/st;}
 // 
  for(j=0;j<st;j++)
  {  mktimer(tt);
    for(i=0;i<3*num;i++)
   {col3[i]+=col2[i]; col1[i]=(char)(col3[i]>>4);
    if(col2[i]>=0&&col1[i]>col[i]||col2[i]<0&&col1[i]<col[i]) col1[i]=col[i];
   }
   setColor256(col1,beg,num);
     while(mktimer()==0);		//  ࢠ
  }
    setColor256(col,beg,num);		//஫쭮 祭 ࠭
    free(col1); free(col2); free(col3);
   return 0;
} // ===================    ====================







// ==============  祭 ࠭ ===================
int screenOn(char far *col,		//
	     int st=30,			//᫮ 蠣  祭
	     float t=0.5)		//६ 祭 ࠭
{  struct palettetype pal;		//  
    char *colOld;			//ࠡ稩 
    int num, beg;			//砫 ॣ.  ᫮ ॣ஢
    int i;				//ࠡ稥 ६
   getpalette(&pal);			//뢠 
  if (pal.size != 0)			//। . ॣ.  ᫮ ॣ.
   { num=pal.colors[0];  beg=pal.colors[0];
     for (i=0; i<pal.size; i++)
      { if(pal.colors[i]>num) num=pal.colors[i];
	if(pal.colors[i]<beg) beg=pal.colors[i];}
      num=num-beg+1;
   }
  if(st>63) st=63; if(st<1) st=1;	//஫ ᫠ 室
  colOld=(char*)malloc(3*num);		//  
  if(colOld==NULL) {printf("\n 墠⠥ !\n");return 1;}
  for(i=0;i<3*num;i++) colOld[i]=0;	//. ⠭ 
 screenPal(col,colOld,st,t,beg,num);	// 
    free(colOld);
   return 0;
} // ============   祭 ࠭ ===============








// ==============  襭 ࠭ ===================
int screenOff(int st = 30,		//st - ᫮ 蠣  몫祭
	      float t=0.5)		//६ 襭 ࠭
{  struct palettetype pal;		//  
    char *col, *colOld;			//ࠡ稥 
    int num, beg;			//砫 ॣ.  ᫮ ॣ஢
    int i;
   getpalette(&pal);			//⠫ 
  if (pal.size != 0)			//।塞 . ॣ.  ᫮ ॣ.
   { num=pal.colors[0];  beg=pal.colors[0];
     for (i=0; i<pal.size; i++)
      { if(pal.colors[i]>num) num=pal.colors[i];
	if(pal.colors[i]<beg) beg=pal.colors[i];}
      num=num-beg+1;
   }
 if(st>63) st=63; if(st<1) st=1;	//஫ ᫠ 室
  col=(char*)malloc(3*num); colOld=(char*)malloc(3*num); //  ஢
  if(col==NULL||colOld==NULL) {printf("\n 墠⠥ !\n"); return 1;}
   getColor(colOld,beg,num);		// ⥪饩 
   for(i=0;i<3*num;i++) col[i]=0;	// 筮 
  screenPal(col,colOld,st,t,beg,num);	// 
    free(col); free(colOld);
   return 0;
} // ============   襭 ࠭ ===============









// ============== ⠭ 㪠⥫  ⨭ ==================
int PosPoint(char *nfile,	// ᭮ 䠩
	     int picN,		// ⨭
	     char *picFile)	//䠩 ⨭
{  extern FILE *fp;		//⮪  ᭮ 䠩
   char sign2[] = "bbb";	//2-  ᨣ ⨭
   char sign1[] = "aaa";	//1-  ᨣ ⨭
   char buf1[4], buf2[4];	//  뢠 ᨣ
   int numPic=0;		//  ⨭
   FILE *in;			//⮪  ⨭
// ---------  ᨣ ----------
  if(fp==NULL) fp=fopen(nfile,"r+b");
  if(fp==NULL) {printf("  %s  !\n",nfile); return 1;}
 int flagL=2; if(ftell(fp)==0) flagL=1;
   while(flagL>0)
  { numPic = -1;
    fread(&buf1, 1, 1, fp);
    if (feof(fp)!=0) {if(--flagL>0) fp=fopen(nfile,"r+b"); continue;}
    if (buf1[0]==sign1[0])
      {	fseek(fp, -1, SEEK_CUR);
	fread(&buf1, 1, 3, fp);
	fread(&buf2, 1, 3, fp);
	fread(&numPic, 2, 1, fp);	//뢠  ⨭
	buf1[3] = 0; buf2[3] = 0;	//-ᨬ
    // ----- ᨣ? -----
     if(!strcmp(buf1, sign1) && !strcmp(buf2, sign2) && numPic==picN)
       return 0;
     else
       if(feof(fp)!=0) {if(--flagL>0) fp=fopen(nfile,"r+b"); continue;}
	fseek(fp, -7, SEEK_CUR);	// 㪠⥫
      }
  }
    if (numPic==-1)	//᫨  ᨣ
      {  // --------  ᨣ ----------
	fseek(fp, 0L, SEEK_END);	//㪠⥫ ->  䠩
	fwrite(&sign1, 1, 3, fp);	// 1  ᨣ
	fwrite(&sign2, 1, 3, fp);	// 2  ᨣ
	fwrite(&picN, 2, 1, fp);	//  ⨭
	long strmP = ftell(fp);		// 砫 ⨭
       if((in = fopen(picFile, "r+b"))==NULL)	//⨥ 䠩 ⨭
	 {printf("    %s\n", picFile); return 1;}
	  // ------  䠩 ⨭ -------
       for (;;)
	{ fread(&buf1, 1, 1, in);
	  if (feof(in)!=0)  break;
	  fwrite(&buf1, 1, 1, fp);
	}
     fclose(in);
     fseek(fp, strmP, SEEK_SET);
      }
   return 0;
} // ===========  ⠭ 㪠⥫  ⨭ ==============







// ================ 뢮 ப ᥫ  ࠭ ===============
void  LinePixel
(unsigned char far *planes,	//㪠⥫ 
	  int  widthStr,	//᫮   ப
	  int  skipByte,	//᪮쪮 ⮢ ய
 unsigned char begMask,		//砫쭠 ᪠
	  int  fullByte,	//᪮쪮 ⮢ 뢥
 unsigned char endMask,		//筠 ᪠
 unsigned int x,		// ப  ࠭
 unsigned int y)
{ unsigned char far *pl;	//⥪騩 㪠⥫  ப
  unsigned char far *m;		//⥪騩 㪠⥫  
  unsigned char far *strBeg;	//砫 ப  
  char col = 0;			//梥
  char npl = 4;			//᫮ ᪮⥩
  int  sl;			// ப  ( )
// 뢠  ப  ( )
 asm{push ds;mov ax,0x40;mov ds,ax;mov ax,[0x4a];mov sl,ax;pop ds}
// 砫 ப   ( ࠭ )
 strBeg=(unsigned char far*)(EgaBase+y*sl+(x>>3));
 op=COPY; openScreen(col);	//- ॣ஢  
 pl=planes+skipByte;		//. 㪠⥫  ப
// ---------- ᥭ ப   -------------
 asm{push si;push di;push ds;push es;
  les di,strBeg;mov bx,di;add bx,fullByte;xor ah,ah;mov ch,0xFF;mov dx,0x3CF}
 a0: asm{cmp begMask,0;je a1;mov al,8;dec dx;out dx,al;mov al,begMask;
  inc dx;out dx,al;mov al,es:[di];mov es:[di],ah;inc di}
 a1:  asm{cmp bx,di;jb a2;dec dx;mov al,8;out dx,al;mov al,ch;
  inc dx;out dx,al;mov al,es:[di];mov es:[di],ah;inc di;jmp short a1}
 a2: asm{cmp endMask,0;je a3;mov al,8;dec dx;out dx,al;mov al,endMask;
  inc dx;out dx,al;mov al,es:[di];mov es:[di],ah;}
 a3: asm{mov col,1;dec dx;mov al,0;out dx,al;mov al,col;inc dx;out dx,al;
  dec dx;mov al,1;out dx,al;mov al,0x0F;inc dx;out dx,al;dec dx;
  mov al,3;out dx,al;mov al,0;inc dx;out dx,al;lds si,pl;mov cx,si;}
 b0: asm{les di,strBeg;cmp begMask,0;je b1;mov al,8;dec dx;
  out dx,al;mov al,[si];and al,begMask;inc dx;out dx,al;
  mov al,es:[di];mov es:[di],ah;inc si;inc di;}
 b1:  asm{cmp bx,di;jb b2;dec dx;mov al,8;out dx,al;mov al,[si];
  inc dx;out dx,al;mov al,es:[di];mov es:[di],ah;inc si;inc di;jmp short b1}
 b2: asm{cmp endMask,0;je b3;mov al,8;dec dx;out dx,al;mov al,[si];
  and al,endMask;inc dx;out dx,al;mov al,es:[di];mov es:[di],ah;}
 b3: asm{add cx,widthStr;mov si,cx;shl col,1;
  dec dx;mov al,0;out dx,al;mov al,col;inc dx;out dx,al;
  dec dx;mov al,1;out dx,al;mov al,0x0F;inc dx;out dx,al;
  dec dx;mov al,3;out dx,al;mov al,0x10;inc dx;out dx,al;
  dec npl;jg b0;pop es;pop ds;pop di;pop si;}
 // ----- ⮢  室 -----
   op=COPY; openScreen(1);  closeScreen();
} // ============  뢮 ப ᥫ  ࠭ ==============









//////////////////////////  .PCX ///////////////////////////

static  PCXheader  ph;		//६  䠩 .PCX



// ======== 뢠    .PCX =========
int   headerPCX(FILE *fp,		// ⮪
	  unsigned char far* pic,	//쭮  obj-䠩
	  PCXheader  *ph,		//
	  unsigned char *colorBuf)	//  
{ int i=0;			//ࠡ ६
// --- 뢠  䠩 ---
 if(fp==NULL) for(i=0;i<sizeof(PCXheader);i++) *((char far*)ph+i)=pic[i];
  else fread(ph, sizeof(PCXheader), 1, fp);
// ----- 饬 த .PCX ------
 if(ph->encod>1||ph->bitpx<1||ph->bitpx>2||ph->nplanes<0||ph->nplanes>4)
   return 1;
// --------- ⥭  ------------
  for(i=0;i<=15;i++)
    { colorBuf[3*i]=(ph->clrma[3*i]);
      colorBuf[3*i+1]=(ph->clrma[3*i+1]);
      colorBuf[3*i+2]=(ph->clrma[3*i+2]);
    }
  return 0;
} // =====  뢠    .PCX =====








// ================ 뢮 ⨭ .PCX  ࠭ ================
int  writePCX(FILE *fp,		// ⮪
	unsigned char far* pic,	//쭮  obj-䠩
	PCXheader ph,		//㪠⥫ 
	int xS=0, int yS=0,	// ࠣ  ࠭
	int dx=0, int dy=0,	//ᬥ饭 ࠣ
	int dw=-1, int dh=-1)	//ਭ   ࠣ
{
   int    skipByte,		//᪮쪮 ⮢ ய
	  fullByte;		//᫮  ⮢
unsigned char begMask,		//砫쭠 ᪠
	      endMask;		//筠 ᪠
   int k;			//ࠡ. ६
   int n;			// ப   ()
   int y;			//⥪ ப
   int l;			//ࠡ ६
  unsigned char *planes;	//  ᯠ ப
  unsigned char	   c;		//࠭⥫ 
   int Width;			//᫮ ⮢  ப
   int fl;			//䫠 ⨭ (1 - 㦥)
   n = ph.nplanes * ph.bplin;	//᫮ ᪮⥩ * ᫮ ⮢  ப
  planes = (unsigned char*)malloc(n+4);  //  ᯠ ப
  Width = ph.bplin;		//᫮ ⮢  ப
 if(fp==NULL) fl=0; else fl=1;	//⠭ 䫠 ⨭
// -------  室   ⨬ --------
    if(dw==-1) dw=ph.x2-ph.x1+1; if(dh==-1) dh=ph.y2-ph.y1+1;
    if (dw<0 || dh<0)  return 2;
    if (dx<0) { if (dw+dx<=0) return 2;  else {dw+=dx; dx = 0;} }
    if (dy<0) { if (dh+dy<=0) return 2;  else {dh+=dy; dy = 0;} }
    if (dw>(ph.x2-ph.x1+1)-dx)  dw = (ph.x2-ph.x1+1)-dx;
// ---------- । 稪  ᮪ -------------
   skipByte = ((ph.x1 & 0x7)+dx) >> 3;		//ய ⮢
   begMask = 0xFF>>(xS & 0x7);			//砫쭠 ᪠
   fullByte = (dw-(8-(xS & 0x7))) >> 3;		//᫮  ⮢
   endMask = 0xFF << (8-((xS+dw) & 0x7));	//筠 ᪠
 l = ((ph.x1+dx) & 0x7) - (xS & 0x7);	//ᬥ饭  (ph.x1+dx)  xS
// --------- 뢮 ࠦ ---------
   pic+=sizeof(PCXheader);
  int picSeg=FP_SEG(pic);  int picOff=FP_OFF(pic);  //ᥣ.  ᬥ. ⨭
  int plOff=FP_OFF(planes);			    //ᬥ.  ப
 // ------------ 뢮 ࠦ  ࠭ ------------
    for (y=0; y<=ph.y2-ph.y1; y++)
 { // ------    ப  obj-⨭ ------
    asm{cld;push es;push di;
    mov ax,ds;mov es,ax;mov di,plOff;mov bx,di;add bx,n;
    cmp fl,0;jne f1;
    push ds;push si;mov ax,picSeg;mov ds,ax;mov si,picOff;}
 lx: asm{lodsb;mov cx,1;mov ah,al;and ah,0xc0;cmp ah,0xc0;jne lm;
    mov cl,al;and cl,0x3F;xor ch,ch;lodsb;}
 lm: asm{rep stosb;cmp di,bx;jb lx;
    mov picOff,si; test si,si;jns lv;mov ax,si;mov cl,4;
    shr ax,cl;add picSeg,ax;and si,0xf;mov picOff,si;jmp short lv;}
   // -------  ப  㦥 ⨭ -------
 f1: asm{push bx;}  fread(&c,1,1,fp);
    asm{pop bx;mov al,c;mov cx,1;mov ah,al;and ah,0xc0;cmp ah,0xc0;jne lm1;
    mov cl,al;and cl,0x3F;xor ch,ch;push cx;push bx;}  fread(&c,1,1,fp);
    asm{pop bx;pop cx;mov al,c;}
 lm1: asm{rep stosb;cmp di,bx;jb f1;jmp short lv1;}
 lv:  asm{pop si;pop ds;}
 lv1: asm{pop di;pop es;}
    if (y>=dy+dh)  break;
 if (y>=dy)	 // ᤢ ப  l
  { asm{push ds;push es;push si;push di;push bp; cmp l,0;je ld1;jl ld;
     //ᤢ 
    mov ax,plOff;mov si,ax;mov dx,l;mov cx,8;sub cx,dx;
    mov dh,cl;mov bh,0xff;shl bh,cl;
    mov bp,n;add bp,si;}
 ls: asm{lodsb;mov bl,[si];dec si;mov cl,dl;shl al,cl;and bl,bh;
    mov cl,dh;shr bl,cl;or al,bl;mov [si],al;inc si;
    cmp si,bp;jb ls;jmp short ld1;}
    //ᤢ ࠢ
 ld: asm{mov cx,8;mov dx,l;neg dx;sub cx,dx;mov dh,cl;mov bh,0xff;
    shr bh,cl;mov ax,n;add ax,2;mov bp,plOff;mov si,bp;add si,ax;}
 ls1: asm{lodsb;mov ah,al;and ah,bh;mov cl,dh;shl ah,cl;or [si],ah;
    mov cl,dl;shr al,cl;dec si;mov [si],al;dec si;cmp si,bp;jae ls1;}
 ld1: asm{pop bp;pop di;pop si;pop es;pop ds;}
  LinePixel(planes,Width,skipByte,begMask,fullByte,endMask,xS,yS+y-dy);
  }
 }
// ------ ⮢  室 --------
   op=COPY; openScreen(1); closeScreen();
   free(planes);
   return 0;
} // =============  뢮 ⨭ .PCX  ࠭ ============









// ===============    ⨭ .PCX ===============
int  getPCX(FILE *fp,		// ⮪
      unsigned char far* pic,	//쭮  obj-⨭ (public name)
      PCXheader ph,		//
      unsigned char huge *Buf,	//㪠⥫ 
      int dx=0, int dy=0,	//ᬥ饭 ࠣ ( ᥫ)
      int w=-1, int h=-1)	//ਭ   ࠣ ( ᥫ)
{
  int  skipByte;		//᪮쪮 ⮢ ய
  int  dwPl;			//᫮ ⮢   ᪮
   int n;			// ப   ()
   int y;			//⥪ ப
   int l,i;			//ࠡ稥 ६
   int fl;			//䫠 ⨭ (1 - 㦥)
  unsigned char c;		// ਥ ᨬ
  unsigned char *planes;	//  ᯠ ப
 if(w==-1) w=ph.x2-ph.x1+1; if(h==-1) h=ph.y2-ph.y1+1; //ࠧ  㬮.
   n = ph.nplanes * ph.bplin;	//᫮ ᪮⥩ * ᫮ ⮢  ப
  planes = (unsigned char*)malloc(n+4); //  ᯠ ப
   dwPl = (w + 7) >> 3;			//᫮ ⮢  ப ࠣ
   skipByte = ((ph.x1 & 0x7)+dx) >> 3;	//ய ⮢
   l = (ph.x1+dx) & 0x7;	//ᬥ饭 (ph.x1+dx)  ࠭ 
 // ---------    ࠧ஢ ࠦ ------------
     Buf[0]=(char)(w-1);		//.   ࠦ
     Buf[1]=(char)((w-1)>>8);		//.   ࠦ
     Buf[2]=(char)(h-1);		//.  ਭ ࠦ
     Buf[3]=(char)((h-1)>>8);          //.  ਭ ࠦ
 // ---------  ப ࠦ ---------
 if(fp==NULL) fl=0; else fl=1;	//⠭ 䫠 ⨭
  pic+=sizeof(PCXheader);
 int BufSeg=FP_SEG(Buf);  int BufOff=FP_OFF(Buf)+4; //ᥣ.  ᬥ. 
 int picSeg=FP_SEG(pic);  int picOff=FP_OFF(pic);   //ᥣ.  ᬥ. ⨭
  int plOff=FP_OFF(planes);			    //ᬥ.  ப
  int bb=ph.bplin;				    //᫮   ᪮
 // ----------- 横  ⨭ ------------
    for (y=0; y<=ph.y2-ph.y1; y++)
 { // ------    ப  obj-⨭ ------
    asm{cld;push es;push di;
    mov ax,ds;mov es,ax;mov di,plOff;mov bx,di;add bx,n;
    cmp fl,0;jne f1;
    push ds;push si;mov ax,picSeg;mov ds,ax;mov si,picOff;}
 lx: asm{lodsb;mov cx,1;mov ah,al;and ah,0xc0;cmp ah,0xc0;jne lm;
    mov cl,al;and cl,0x3F;xor ch,ch;lodsb;}
 lm: asm{rep stosb;cmp di,bx;jb lx;
    mov picOff,si; test si,si;jns lv;mov ax,si;mov cl,4;
    shr ax,cl;add picSeg,ax;and si,0xf;mov picOff,si;jmp short lv;}
   // -------  ப  㦥 ⨭ -------
 f1: asm{push bx;}  fread(&c,1,1,fp);
    asm{pop bx;mov al,c;mov cx,1;mov ah,al;and ah,0xc0;cmp ah,0xc0;jne lm1;
    mov cl,al;and cl,0x3F;xor ch,ch;push cx;push bx;}  fread(&c,1,1,fp);
    asm{pop bx;pop cx;mov al,c;}
 lm1: asm{rep stosb;cmp di,bx;jb f1;jmp short lv1;}
 lv:  asm{pop si;pop ds;}
 lv1: asm{pop di;pop es;}
   if (y>=dy+h)   break;
 if (y>=dy)
  {// --------- ᤢ ப   l ᥫ ----------
 asm{push ds;push es;push si;push di;
    push bp;cmp l,0;jbe ld;
    mov ax,plOff;mov si,ax;mov dx,l;mov cx,8;sub cx,dx;
    mov dh,cl;mov bh,0xff;shl bh,cl;mov bp,n;add bp,si;}
 ls: asm{lodsb;mov bl,[si];dec si;mov cl,dl;shl al,cl;and bl,bh;
    mov cl,dh;shr bl,cl;or al,bl;mov [si],al;inc si;cmp si,bp;jb ls;}
 // ᥭ   ப  ᬥ 浪 ᪮⥩ ( putimage)
 ld: asm{pop bp;mov dx,BufSeg;mov es,dx;mov dx,BufOff;mov bx,plOff;
    add bx,skipByte;add bx,bb;add bx,bb;add bx,bb;mov i,4}
 lr: asm{mov di,dx;mov cx,dwPl;mov si,bx;}
 lp: asm{lodsb;stosb;loop lp;sub bx,bb;add dx,dwPl;dec i;ja lr;
    mov BufOff,dx;test dx,dx;jns lk; mov ax,dx;mov cl,4;shr ax,cl;
    add BufSeg,ax;and dx,0xf;mov BufOff,dx;}
 lk: asm{ pop di;pop si;pop es;pop ds;}
  }
 } // ------ ⮢  室 --------
   op=COPY; openScreen(1); closeScreen();
   free(planes);
   return 0;
} // ===========   ⨭ .PCX   ==========









// ============ 뤥   ࠦ =============
unsigned char huge*  memoPic(int w, int h)
		//頥 㪠⥫  뤥 
		//w-ਭ  h- ࠣ ( ᥫ)
{ unsigned long sizeBuf;		//ࠧ   ⨭
  unsigned char huge *Buf;		//  ⨭
  sizeBuf = 6 + (((long)w+15)>>3)*4*((long)h+1);
  Buf = (unsigned char huge*)farmalloc(sizeBuf);
  if(Buf==NULL) {printf(" 墠⠥ !\n"); return NULL;}
     Buf[0]=(char)(w-1);		//.   ࠦ
     Buf[1]=(char)((w-1)>>8);		//.   ࠦ
     Buf[2]=(char)(h-1);		//.  ਭ ࠦ
     Buf[3]=(char)((h-1)>>8);		//.  ਭ ࠦ
  return Buf;
}// ==========  뤥   ࠦ ===========








// ==========  ࠣ     㣮 ===========
int  movePic(unsigned char huge *Buf1,	//㪠⥫ 1- 
	     unsigned char huge *Buf2,	//㪠⥫ 2- (ਥ)
      int m=0,			//᪠
      int dx2=0, int dy2=0,	//ᬥ饭  2-  ( ᥫ)
      int dx1=0, int dy1=0,	//ᬥ饭  1-  ( ᥫ)
      int dw=-1, int dh=-1)	//ਭ   ࠣ ( ᥫ)
{ int  skipB1,skipB2,		//᪮쪮 ⮢ ய
       fullB;			//᫮  ⮢
  unsigned char lBeg,rBeg;	//砫 ᪨ (  ࠢ)
  unsigned char	lEnd,rEnd;	// ᪨ (  ࠢ)
  unsigned int	lEn,rEn;	// ᪨ (  ࠢ)
  long n1,n2;			//᫮   ᪮
  long i1,i2,ii1,ii2,iE,	//  
       ii1a, ii2a;
  char  l, l1;			// ᬥ饭  
  int y;			//⥪ ப
  int i,sh,ia1,ib1,ia2,ib2;
// --------- 뢠 ࠧ஢ ஢ ------------
  int wB1=Buf1[1]<<8|Buf1[0]+1; int hB1=Buf1[3]<<8|Buf1[2]+1;
  int wB2=Buf2[1]<<8|Buf2[0]+1; int hB2=Buf2[3]<<8|Buf2[2]+1;
// -------  室  --------
   if(dx1>=wB1||dy1>=hB1||dx2>=wB2||dy2>=hB2) return 1;
   if(dw==-1 || dw>wB1) dw=wB1; if(dh==-1 || dh>hB1) dh=hB1;
  if(dx1+dw>wB1) dw=wB1-dx1;   if((dy1+dh)>hB1) dh=hB1-dy1;
  if(dx2+dw>wB2) dw=wB2-dx2;   if((dy2+dh)>hB2) dh=hB2-dy2;
   if((dx2&7)+dw<8) sh=1; else sh=0;  //㧪 ࠦ( 8 ᥫ)
// ---------- । 稪  ᮪ -------------
     n1=(wB1+7)>>3;      //᫮ ⮢  ᪮ 1- 
     n2=(wB2+7)>>3;      //᫮ ⮢  ᪮ 2- 
   skipB1 = dx1 >> 3;			//ய ⮢
   skipB2 = dx2 >> 3;			//ய ⮢
    rBeg = 0xFF >> (dx2 & 7);		//砫쭠 ᪠ ࠢ
    lBeg = ~rBeg;            		//砫쭠 ᪠ 
   fullB=dw-(8-(dx2&7))>>3;		//᫮  ⮢
    rEnd=0xFF>>((dx2+dw)&7);
    lEnd=~rEnd;
    rEn=0xFFFF>>((dx2+dw)&7);	//筠 ᪠ ࠢ
    if(fullB&1==1) rEn>>=8;	//४ ᪨  ⭮
    lEn = ~rEn;			//筠 ᪠ 
   l = (dx1&7)-(dx2&7);		// ᬥ饭
// ------- ७ᥭ ࠦ --------
    ii1a=n1<<2;  ii1=4+ii1a*dy1+skipB1;
    ii2a=n2<<2;  ii2=4+ii2a*dy2+skipB2;
  if(l<=0)			//ᤢ ࠢ  l ᥫ
    { l=-l;  l1 = 8-l;
     for(y=0; y<dh; y++)		//y-⥪ ப ᥫ
      { i1=ii1; i2=ii2;
       for(i=0; i<4; i++)
	{ ia1=(int)(i1>>4); ib1=(int)i1 & 0xf;
	  ia2=(int)(i2>>4); ib2=(int)i2 & 0xf;
 asm{ push ax;push bx;push cx;push dx;push si;push di;push ds;push es;
      lds si,Buf1; mov dx,ds; add dx,ia1; mov ds,dx; add si,ib1;cld;
      les di,Buf2; mov dx,es; add dx,ia2; mov es,dx; add di,ib2;mov bx,si;
      add bx,fullB;lodsb;mov ch,al;mov cl,l;shr al,cl;mov ah,es:[di];
	  cmp sh,0; je ma0;
//----- 㧪 ࠦ ( 8 ᥫ) -----
	  cmp m,0; jne s1; jmp se}
  s1: asm{cmp m,1; jne s2; xor al,ah; jmp se}
  s2: asm{cmp m,2; jne s3;  or al,ah; jmp se}
  s3: asm{cmp m,3; jne s4; and al,ah; jmp se}
  s4: asm{cmp m,4; jne ma5; not al}
  se: asm{and al,rBeg;and al,lEnd;mov dl,ah;and ah,lBeg;and dl,rEnd;
	  or ah,dl;or al,ah;stosb;jmp ma5;}
//----- ப ࠦ ( 8 ᥫ) -----
 ma0: asm{cmp m,0; jne ma1;		//COPY_PUT
   and al,rBeg;and ah,lBeg;or al,ah;stosb;}
 B0: asm{cmp bx,si;jbe C0;mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;
   mov ch,al;mov cl,l;shr ax,cl;or ah,dl;xchg al,ah;stosw;jmp B0}
 C0:asm{mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;mov cl,l;shr ax,cl;
   or ah,dl;mov dx,es:[di];xchg dl,dh;and ax,lEn;jmp me;}
 ma1: asm{cmp m,1; jne ma2;		//XOR_PUT
   xor al,ah;and al,rBeg;and ah,lBeg;or al,ah;stosb;}
 B1: asm{cmp bx,si;jbe C1;mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;
   mov ch,al;mov cl,l;shr ax,cl;or ah,dl;xchg al,ah;xor es:[di],ax;add di,2;
   jmp B1}
 C1:asm{mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;mov cl,l;shr ax,cl;
   or ah,dl;mov dx,es:[di];xchg dl,dh;xor ax,dx;and ax,lEn;jmp me;}
 ma2: asm{cmp m,2; jne ma3;		//OR_PUT
   or al,ah;and al,rBeg;and ah,lBeg;or al,ah;stosb;}
 B2: asm{cmp bx,si;jbe C2;mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;
   mov ch,al;mov cl,l;shr ax,cl;or ah,dl;xchg al,ah;or es:[di],ax;add di,2;
   jmp B2}
 C2:asm{mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;mov cl,l;shr ax,cl;
   or ah,dl;mov dx,es:[di];xchg dl,dh;or ax,dx;and ax,lEn;jmp me;}
 ma3: asm{cmp m,3; jne ma4;		//AND_PUT
   and al,ah;and al,rBeg;and ah,lBeg;or al,ah;stosb;}
 B3: asm{cmp bx,si;jbe C3;mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;
   mov ch,al;mov cl,l;shr ax,cl;or ah,dl;xchg al,ah;and es:[di],ax;add di,2;
   jmp B3}
 C3:asm{mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;mov cl,l;shr ax,cl;
   or ah,dl;mov dx,es:[di];xchg dl,dh;and ax,dx;and ax,lEn;jmp me;}
 ma4: asm{cmp m,4; jne ma5;		//NOT_PUT
   not al;and al,rBeg;and ah,lBeg;or al,ah;stosb;}
 B4: asm{cmp bx,si;jbe C4;mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;
   mov ch,al;mov cl,l;shr ax,cl;or ah,dl;not ax;xchg al,ah;stosw;jmp B4}
 C4:asm{mov dl,ch;mov cl,l1;shl dl,cl;lodsw;xchg al,ah;mov cl,l;shr ax,cl;
   or ah,dl;mov dx,es:[di];xchg dl,dh;not ax;and ax,lEn;jmp me;}
 me:  asm{and dx,rEn;or ax,dx;xchg al,ah;stosw;}
 ma5: asm{pop es;pop ds;pop di;pop si;pop dx;pop cx;pop bx;pop ax}
     i1+=n1; i2+=n2;
	}
     ii1+=ii1a; ii2+=ii2a;
      }
    }
  else			//ᤢ   l ᥫ
    {l1 = 8-l;  fullB++;
     for(y=0; y<dh; y++)			//y-⥪ ப ᥫ
      { i1=ii1; i2=ii2;
       for(i=0; i<4; i++)
	{ ia1=(int)(i1>>4); ib1=(int)i1 & 0xf;
	  ia2=(int)(i2>>4); ib2=(int)i2 & 0xf;
 asm{ push ax;push bx;push cx;push dx;push si;push di;push ds;push es;
      lds si,Buf1; mov dx,ds; add dx,ia1; mov ds,dx; add si,ib1;cld;
      les di,Buf2; mov dx,es; add dx,ia2; mov es,dx; add di,ib2;mov bx,si;
  add bx,fullB;lodsb;mov cl,l;shl al,cl;mov dl,[si];mov cl,l1;shr dl,cl;
  or al,dl;mov dl,es:[di];mov ch,dl;and dl,lBeg;
	  cmp sh,0; je mb0;
//----- 㧪 ࠦ ( 8 ᥫ) -----
	  cmp m,0; jne r1; jmp re}
  r1: asm{cmp m,1; jne r2; xor al,ch; jmp re}
  r2: asm{cmp m,2; jne r3;  or al,ch; jmp re}
  r3: asm{cmp m,3; jne r4; and al,ch; jmp re}
  r4: asm{cmp m,4; jne mb5; not al}
  re: asm{and al,rBeg;and al,lEnd;and ch,rEnd;or dl,ch;or al,dl;stosb;jmp mb5}
//----- ப ࠦ ( 8 ᥫ) -----
 mb0: asm{ cmp m,0; jne mb1;		//COPY_PUT
  and al,rBeg;or al,dl;stosb;lodsw;xchg al,ah;mov dx,ax;}
 D0: asm{cmp bx,si;jb E0;mov cl,l;shl dx,cl;lodsw;xchg al,ah;mov ch,ah;
  mov cl,l1;shr ch,cl;or dl,ch;xchg dl,dh;xchg ax,dx;stosw;jmp D0}
 E0: asm{mov cl,l;shl dx,cl;lodsb;mov cl,l1;shr al,cl;or dl,al;mov ax,es:[di];
  xchg al,ah;jmp mf}
 mb1: asm{ cmp m,1; jne mb2;		//XOR_PUT
  xor al,ch;and al,rBeg;or al,dl;stosb;lodsw;xchg al,ah;mov dx,ax;}
 D1: asm{cmp bx,si;jb E1;mov cl,l;shl dx,cl;lodsw;xchg al,ah;mov ch,ah;
  mov cl,l1;shr ch,cl;or dl,ch;xchg dl,dh;xchg ax,dx;xor es:[di],ax;add di,2;
  jmp D1}
 E1: asm{mov cl,l;shl dx,cl;lodsb;mov cl,l1;shr al,cl;or dl,al;mov ax,es:[di];
  xchg al,ah;xor dx,ax;jmp mf}
 mb2: asm{ cmp m,2; jne mb3;		//OR_PUT
  or al,ch;and al,rBeg;or al,dl;stosb;lodsw;xchg al,ah;mov dx,ax;}
 D2: asm{cmp bx,si;jb E2;mov cl,l;shl dx,cl;lodsw;xchg al,ah;mov ch,ah;
  mov cl,l1;shr ch,cl;or dl,ch;xchg dl,dh;xchg ax,dx;or es:[di],ax;add di,2;
  jmp D2}
 E2: asm{mov cl,l;shl dx,cl;lodsb;mov cl,l1;shr al,cl;or dl,al;mov ax,es:[di];
  xchg al,ah;or dx,ax;jmp mf}
 mb3: asm{ cmp m,3; jne mb4;		//AND_PUT
  and al,ch;and al,rBeg;or al,dl;stosb;lodsw;xchg al,ah;mov dx,ax;}
 D3: asm{cmp bx,si;jb E3;mov cl,l;shl dx,cl;lodsw;xchg al,ah;mov ch,ah;
  mov cl,l1;shr ch,cl;or dl,ch;xchg dl,dh;xchg ax,dx;and es:[di],ax;add di,2;
  jmp D3}
 E3: asm{mov cl,l;shl dx,cl;lodsb;mov cl,l1;shr al,cl;or dl,al;mov ax,es:[di];
  xchg al,ah;and dx,ax;jmp mf}
 mb4: asm{ cmp m,4; jne mb5;		//NOT_PUT
  not al;and al,rBeg;or al,dl;stosb;lodsw;xchg al,ah;mov dx,ax;}
 D4: asm{cmp bx,si;jb E4;mov cl,l;shl dx,cl;lodsw;xchg al,ah;mov ch,ah;
  mov cl,l1;shr ch,cl;or dl,ch;xchg dl,dh;xchg ax,dx;not ax;stosw;jmp D4}
 E4: asm{mov cl,l;shl dx,cl;lodsb;mov cl,l1;shr al,cl;or dl,al;mov ax,es:[di];
  xchg al,ah;not dx;jmp mf}
 mf:asm{and dx,lEn;and ax,rEn;or ax,dx;xchg al,ah;stosw;}
 mb5:asm{pop es;pop ds;pop di;pop si;pop dx;pop cx;pop bx;pop ax}
    i1+=n1; i2+=n2;
	}
    ii1+=ii1a; ii2+=ii2a;
      }
    }
  return 0;
} // =======   ࠣ     㣮 =======







// ===============  ࠦ ===================
int  floatPic(unsigned char huge *Buf,	//㪠⥫ 
      int dx=0, int dy=0,	//  ࠭ ( ᥫ)
      int qw=1, int qh=1,	//ࠧ ௨稪
      int m=COPY_PUT,		//᪠ 뢮 ࠦ
      float t=0.7)		//६ 뢮 ( ᥪ)
{ randomize();
  unsigned int i,j,ii; long k,z;	//ࠡ稥 ६
     k=Buf[1]<<8|Buf[0]+1;		//ࠧ  ਧ⠫  ᥫ
   int jmax=k/qw;			//ࠧ  ਧ⠫  ௨稪
   int hqw=k-(long)jmax*(long)qw; jmax++;
     k=Buf[3]<<8|Buf[2]+1;              //ࠧ  ⨪  ᥫ
   int imax=k/qh;                       //ࠧ  ⨪  ௨稪
   int hqh=k-(long)imax*(long)qh; imax++;
   unsigned char huge *Buf1=memoPic(qw,qh);	//௨稪 ७
   unsigned char huge *Buf2=memoPic(hqw,qh);	//௨稪 ࠢ
   unsigned char huge *Buf3=memoPic(qw,hqh);	//௨稪 
   unsigned char huge *Buf4=memoPic(hqw,hqh);	//௨稪 ࠢ-
  unsigned int maxl=(long)imax*(long)jmax/8;	//ࠧ  䫠
   i=(long)imax*(long)jmax%8; if(i!=0) maxl+=1;
  unsigned char huge *arnum=(unsigned char huge*)farmalloc(maxl);// 䫠
   for(k=0;k<maxl;k++) arnum[k]=0;		//㫥  䫠
   if(i!=0) {arnum[maxl-1]=0xff; arnum[maxl-1]>>=i;}	//᫥ 
  unsigned long tt;			//প  㯯
  float p;				//६   pic
 if(t>0.05) p=0.000976*jmax*imax/t;	//㯯 室  twip'
  float min=p;i=1;
  for(j=1;j<50;j++) if(j*p-floor(j*p)<min) {i=j;min=j*p-floor(j*p);}
  int n=i*p;			//㯯 室
  if(t>0.05) tt=(long)i*976; else{tt=0;n=0;}
     mktimer(tt);		// ⠩
     ii=1;
 for(k=0;k<(long)jmax*(long)imax;k++)
 {     i=random(maxl);j=random(8);
     asm{push si;push di;push ds;push es;
	lds si,arnum;mov es,si;mov di,si;add di,maxl;add si,i;}
 a0: asm{inc si;cmp di,si;ja a1;mov si,es;};
 a1: asm{mov al,[si];cmp al,0xff;je a0;mov cx,j;mov ch,1;shl ch,cl;}
 a2: asm{mov ah,al;test ah,ch;jnz a3;or [si],ch;mov ax,es;
	sub si,ax;mov i,si;mov cl,-1;jmp ae;}
 a3: asm{shl ch,1;jnz a2;mov ch,1;jmp a2;}
 ae: asm{inc cl;shl ch,1;jnz ae;mov j,cx;pop es;pop ds;pop di;pop si;}
      z=(long)i*8+j;i=int(z/jmax);j=z-i*jmax;
  //뢮 ௨稪
 if((j!=jmax-1)&&(i!=imax-1))			//७
   {movePic(Buf,Buf1,COPY_PUT,0,0,qw*j,qh*i,qw,qh);
    putimage(dx+qw*j, dy+qh*i,Buf1,m);}
 else
   {if((j==jmax-1)&&(i!=imax-1))                //ࠢ
     {if(hqw==0) continue;
      movePic(Buf,Buf2,COPY_PUT,0,0,qw*j,qh*i,hqw,qh);
      putimage(dx+qw*j, dy+qh*i,Buf2,m);}
    else
     {if((j!=jmax-1)&&(i==imax-1))              //
       {if(hqh==0) continue;
	movePic(Buf,Buf3,COPY_PUT,0,0,qw*j,qh*i,qw,hqh);
	putimage(dx+qw*j, dy+qh*i,Buf3,m);}
      else                                      //ࠢ-
       {if(hqw==0||hqh==0) continue;
	movePic(Buf,Buf4,COPY_PUT,0,0,qw*j,qh*i,hqw,hqh);
	putimage(dx+qw*j, dy+qh*i,Buf4,m);}
     }
   }
 //뢠 ࢠ
  if(tt>0) if(ii<n) ii++; else{ii=1;while(mktimer()==0);mktimer(tt);}
 }
  farfree(arnum);farfree(Buf1);farfree(Buf2);farfree(Buf3);farfree(Buf4);
 return 0;
} // =============   ࠦ ===============







// ====================    ࠭ =====================
void shiftWin(int sx,int sy,	//न  (sx ⭮ 8 ᥫ)
	      int sw,int sh,	//ࠧ  (sw ⭮ 8 ᥫ)
	      int sdx,int sdy)	//ᤢ   ࠭(sdx ⭮ 8 ᥫ)
{  char flFor=0;	//䫠 ࠢ ᤢ
   int  sx0=0, sx1=0;	//砫    
   sx>>=3; sw>>=3; sdx>>=3;	//ॢ  
  if(sdy>0||(sdy==0&&sdx>0)){flFor=1; sy+=(sh-1); sx0=sx1=sw-1;}
   sx0+=sy*80+sx;		//砫   
   sx1+=(sy+sdy)*80+sx+sdx;     //砫 ᤢ⮣   
 // -------- ᬥ饭  -----------
  asm{push ds;push es;push si;push di;push bp;
    mov ax,0x0a000;mov ds,ax;mov dx,sw;mov es,dx;
    mov dx,0x3ce;mov al,5;out dx,al;inc dx;mov al,1;out dx,al;//०. 1
    mov ah,flFor;mov bx,sx0;mov dx,sx1;mov bp,sh;}
  copy: asm{mov si,bx;mov di,dx;mov cx,es;cmp ah,0;jne lback;}
  lfor: asm{mov al,[si];mov [di],al;inc si;inc di;loop lfor;
	 add bx,80;add dx,80;dec bp;ja copy;jmp con;}
  lback: asm{mov al,[si];mov [di],al;dec si;dec di;loop lback;
	 sub bx,80;sub dx,80;dec bp;ja copy;}
  con:  asm{					//⮢  室
    mov dx,0x3ce;mov al,5;out dx,al;inc dx;mov al,0;out dx,al;//०. 0
    pop bp;pop di;pop si;pop es;pop ds;}
}// ================     ࠭ =================






// ============= ⠭ 砫 ࠭   ===============
void screenBegin(int x, int y)		//x, y - न 砫 ࠭
{asm {push es;mov ax,0x40;mov es,ax;
     mov ax,x;mov bx,y;mov cx,8;div cl;mov cl,ah;xor ah,ah;xchg ax,bx;
     mov dx,es:[0x4a];	//᫮ ⮢  ப
     mul dx;add bx,ax;mov dx,es:[0x63];add dl,6;} //ॣ.ﭨ (3D4)
 l1: asm{in al,dx;test al,8;jz l1;}	// 砫 . . 室
 l2: asm{in al,dx;test al,8;jnz l2;	// 砭 . . 室
     cli;sub dl,6;mov ah,bh;mov al,0x0c;out dx,ax;  //. ..( )
     mov ah,bl;inc al;out dx,ax;		    //. ..( )
     sti;add dl,6;}
 l3: asm{in al,dx;and al,8;jz l3;	// 砫 . . 室
     cli;sub dl,6;mov ah,ch;mov al,8;out dx,ax; //.ࢮ ப ࠧ⪨
     mov dx,0x3c0;mov al,0x13;		//0x13 - ॣ. . ࠬ஢
     or al,0x20;out dx,al;mov al,cl;out dx,al; //.ࠬ஢ ᥫ
     sti;pop es;}
} //==========  ⠭ 砫 ࠭   ============






// =========== ⠭ ࠧ஢  ===============
void screenChange(int x, int y)	//x, y - ࠧ 
{
  asm{push es;mov ax,0x40;mov es,ax;mov bx,8;  //ਭ ᥫ
   mov ax,x;div bl;  //al - - ᨬ  ப
   mov es:[0x4a],al; //ᨬ   . . BIOS
   mov bh,al;mov ax,y;div byte ptr es:[0x85];  //al - - ப ᨬ
   dec al;mov es:[0x84],al;  //ᨬ   . . BIOS
   inc al;mul bh;   //ax - . ᨬ  ப * . ᨬ.  ⮡
   mov es:[0x4c],ax;   //ᨬ   . . BIOS
   mov ah,bh;shr ah,1;  // ப  ᫮
   mov al,0x13; // ॣ ஫
   mov dx,es:[0x63];out dx,ax; //⠭ ॣ ᬥ饭 ஫
   pop es;}
} // =========  ⠭ ࠧ஢  ===========







//****************************************************************

/////////////////////////  㭪樨   /////////////////////////

//****************************************************************

 // ----- ⥪騥 न  -----
  int  xMouse=0;
  int  yMouse=0;
 // ----- ࠧ   ------
  int wM=0;
  int hM=0;
 // ----- न    ------
  int xP=0;
  int yP=0;
 // ----- 稪 祭  -----
  int countMouse = 1;
 // ----- ⥪饥   -----
  int  xMCur=0;
  int  yMCur=0;

 char* andMouse;	// AND-᪨ 
 char* orMouse;		// OR-᪨ 
 char huge* fonMouse;	// 䮭
 char huge* bufMouse;	// ନ஢ ࠦ
  int xmax, ymax;	//ࠧ ࠭
  int xbufM, ybufM;	//न  bufMouse
  int dx2,dy2;		//ᬥ饭   
 int flagMoveMouse=1;	//ࠧ襭 뢮    ࠭




// ================= ६饭   ================
void moveMouse(int x, int y,	//x,y - न  
	       int sh=0)	//ࠧ襭 뢮 䮭 ( fonMouse)
{ if(countMouse==0&&flagMoveMouse==0)
 { flagMoveMouse=1;
    int wb,hb;			//ࠧ bufMouse( ନ஢ .)
    int x1,y1,w1,h1;		//  ࠧ ० 
    int x2,y2,w2,h2;		//  ࠧ  
    int dx1,dy1,zx2,zy2;	//ᬥ饭 ஢  
    int dx=x-xMCur; int dy=y-yMCur;	// ᬥ饭 ஢
    x1=xMCur-xP; y1=yMCur-yP; x2=x-xP; y2=y-yP;
 if(dx>=0)
  {dx1=0;if(x1>=0){xbufM=x1;zx2=0;dx2=dx;wb=dx+wM;w1=wM;w2=wM;
    if(xbufM+wb>xmax){wb=xmax-xbufM;w2=wb-dx+1;if(xbufM+wM>xmax) w1=wb+1;}}
	 else{xbufM=0;w1=wM+x1;if(x2>=0){zx2=0;dx2=dx+x1;w2=wM;
	      wb=dx2+w2;}else{zx2=-x2;dx2=0;w2=wM+x2;wb=w2;}}}
 else{dx=-dx;dx2=0; if(x2>=0){xbufM=x2;zx2=0;dx1=dx;wb=dx+wM;w2=wM;w1=wM;
      if(xbufM+wb>xmax){wb=xmax-xbufM;w1=wb-dx+1;if(xbufM+wM>xmax) w2=wb+1;}}
	 else{xbufM=0;zx2=-x2;w2=wM+x2;if(x1>=0){dx1=dx+x2;w1=wM;
	      wb=dx1+w1;}else{;dx1=0;w1=wM+x1;wb=w1;}}}
 if(dy>=0)
   {dy1=0;if(y1>=0){ybufM=y1;zy2=0;dy2=dy;hb=dy+hM;h1=hM;h2=hM;
     if(ybufM+hb>ymax){hb=ymax-ybufM;h2=hb-dy+1;if(ybufM+hM>ymax) h1=hb+1;}}
	 else{ybufM=0;h1=hM+y1;if(y2>=0){zy2=0;dy2=dy+y1;h2=hM;
	      hb=dy2+h2;} else{zy2=-y2;dy2=0;h2=hM+y2;hb=h2;}}}
 else {dy=-dy;dy2=0; if(y2>=0){ybufM=y2;zy2=0;dy1=dy;hb=dy+hM;h2=hM;h1=hM;
	if(ybufM+hb>ymax){hb=ymax-ybufM;h1=hb-dy+1;if(ybufM+hM>ymax) h2=hb+1;}}
	 else{ybufM=0;zy2=-y2;h2=hM+y2;if(y1>=0){dy1=dy+y2;h1=hM;
	      hb=dy1+h1;} else{dy1=0;h1=hM+y1;hb=h1;}}}
 if(wb<=2*wM && hb<=2*hM)	// ᬥ饭  ( 2- ࠧ஢)
  { getimage(xbufM,ybufM,xbufM+wb,ybufM+hb,bufMouse);
    if(!sh) movePic(fonMouse,bufMouse,COPY_PUT,dx1,dy1,0,0,w1,h1);
      fonMouse[0]=(char)(w2-1); fonMouse[1]=0;
      fonMouse[2]=(char)(h2-1); fonMouse[3]=0;
    movePic(bufMouse,fonMouse,COPY_PUT,0,0,dx2,dy2,w2,h2);
    movePic(andMouse,bufMouse,AND_PUT,dx2,dy2,zx2,zy2,w2,h2);  //AND-ࠩ
    movePic( orMouse,bufMouse, OR_PUT,dx2,dy2,zx2,zy2,w2,h2);  //OR-ࠩ
     putimage(xbufM,ybufM,bufMouse,COPY_PUT);
  }
 else				//쭥 ᬥ饭  ( 2- ࠧ஢)
  { if(!sh) putimage(xbufM+dx1,ybufM+dy1,fonMouse,COPY_PUT);
    getimage(xbufM+dx2,ybufM+dy2,xbufM+dx2+w2,ybufM+dy2+h2,bufMouse);
      fonMouse[0]=(char)(w2-1); fonMouse[1]=0;
      fonMouse[2]=(char)(h2-1); fonMouse[3]=0;
    movePic(bufMouse,fonMouse);
    movePic(andMouse,bufMouse,AND_PUT,0,0,zx2,zy2,w2,h2);  //AND-ࠩ
    movePic(orMouse,bufMouse,OR_PUT,0,0,zx2,zy2,w2,h2);   //OR-ࠩ
     putimage(xbufM+dx2,ybufM+dy2,bufMouse,COPY_PUT);
  }
  xMCur=x; yMCur=y;		// न  
  flagMoveMouse=0;
 }
 xMouse=x; yMouse=y;		// न 
} //=================  ६饭   ================





// ============     ===============
int shapeMouse(char far *fileCursor,	//䠩  
	  int xPoint=0, int yPoint=0)	//ਥ  
{  flagMoveMouse=1;
   char col[48];			//  
   headerPCX(NULL,fileCursor,&ph,col);	//䠩  
   //⠭ ࠧ஢ 
    wM=(ph.x2-ph.x1+1)/2; hM=ph.y2-ph.y1+1;
   //⠭ न 
  if(xPoint<=wM&&xPoint>=0&&yPoint<=hM&&yPoint>=0){xP=xPoint;yP=yPoint;}
   else{xP=0;yP=0;}
  farfree(bufMouse); bufMouse=memoPic(2*wM,2*hM);	//  
  farfree(fonMouse); fonMouse=memoPic(wM,hM);	// 䮭
  free(andMouse);free(orMouse);
 andMouse=(char*)malloc(6+(((long)wM+15)>>3)*4*((long)hM+1));  //a AND
 orMouse =(char*)malloc(6+(((long)wM+15)>>3)*4*((long)hM+1));  //᪠ OR
 if(andMouse==NULL||orMouse==NULL){printf(" 墠⠥ !\n"); return 1;}
   getPCX(NULL,fileCursor,ph,andMouse,0,0,wM,hM);  //뢠 ᪨ AND
   getPCX(NULL,fileCursor,ph,orMouse,wM,0,wM,hM);  //뢠 ᪨ OR
  flagMoveMouse=0;
 return 0;
} // ==========      ============





// =========== ⠭ न   ============
void setMouseCursor(int x, int y)	//x, y - न 
{  xMouse=xMCur=x;
   yMouse=yMCur=y;
  asm{mov ax,4;mov cx,x;mov dx,y;int 0x33;}	//⠭ 
} // ==========  ⠭ न  =========




// ================    ================
void  showMouse()
{ //flagMoveMouse=1;
  xmax=getmaxx(); ymax=getmaxy();
  if(--countMouse==0)
  { flagMoveMouse=0;		//ࠧ襭 뢮 
    moveMouse(xMouse, yMouse, 1);	//뢮 
  }
} // ===============     ==============




// ===================    =================
void  hideMouse()
{  flagMoveMouse=1;
  if(countMouse++==0)
    putimage(xbufM+dx2,ybufM+dy2,fonMouse,COPY_PUT);
  flagMoveMouse=0;
} // ===============     ==============




///////////////////////   㭪権   //////////////////////



#endif

