// ========== File Mouse.h ============
// । ६  㭪権 ࠡ  .

// -------------- ६ --------------------
#ifndef  __MOUSE__
#define  __MOUSE__
#define  MOUSE_MOVE_MASK        0x01	//६饭
#define  MOUSE_LBUTTON_PRESS    0x02	//⨥  
#define  MOUSE_LBUTTON_RELEASE  0x04    //᪠  
#define  MOUSE_RBUTTON_PRESS    0x08    //⨥ ࠢ 
#define  MOUSE_RBUTTON_RELEASE  0x10    //᪠ ࠢ 
#define  MOUSE_MBUTTON_PRESS    0x20    //⨥ । 
#define  MOUSE_MBUTTON_RELEASE  0x40    //᪠ । 
#define  MOUSE_ALL_EVENTS       0x7F	// ᮡ⨥

struct  MouseState	//  (न  ﭨ )
{
  int  x,y;
  int  Buttons;
};

struct  CursorShape	// 
{
  unsigned  AndMask [16];
  unsigned  XorMask [16];
  int  HotX, HotY;
};

typedef  void (*MouseHandler)(int, int, int, int);

// -------------------  㭪権 -------------------------
int   ResetMouse();		//樠  ஢ઠ  
void  ShowMouseCursor();	//  
void  HideMouseCursor();	//  
void  ReadMouseState(MouseState&);  // ﭨ 
void  MoveMouseCursor(int, int);    //    न
void  SetHorzMouseRange(int, int);  // ਧ⠫쭮 ६饭
void  SetVertMouseRange(int, int);  // ⨪쭮 ६饭
void  SetMouseShape(CursorShape&);  // 
void  SetHideRange(int, int, int, int);     //⠭  襭
int   MouseIn(int, int, int, int);  //   אַ㣮쭨
void  SetMouseHandler(MouseHandler, int = MOUSE_ALL_EVENTS); //⠭
						     //ࠡ稪 ᮡ⨩
void  RemoveMouseHandler();	    //㤠 ࠡ稪 ᮡ⨩

#define  ClearHideRange()  ShowMouseCursor()
#endif

